﻿Imports System.Data
Imports System.Xml

Partial Class _Default
    Inherits System.Web.UI.Page

    ' Declara as strings para apontar para os arquivos XML and XSD 
    Dim strXmlDocument As String = Server.MapPath("\livro\visitas.xml")
    Dim strXmlSchema As String = Server.MapPath("\livro\visitas.xsd")
    Dim ip As String = ""
    Dim ok As Boolean = True

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            ' Le o arquivo XML em um XmlDataDocument assim podemos acessá-lo via DataSet
            Dim myXmlDataDocument As New XmlDataDocument()
            myXmlDataDocument.DataSet.DataSetName = "LivrodeVisitas"
            myXmlDataDocument.DataSet.ReadXmlSchema(strXmlSchema)
            myXmlDataDocument.Load(strXmlDocument)
            getIP()
            'Vincula a fonte de dados ao repeater
            LivrodeVisitasRepeater.DataSource = myXmlDataDocument.DataSet.Tables("Entrada")
            LivrodeVisitasRepeater.DataBind()
        End If
    End Sub

    Protected Sub btnAssinarLivroVisitas_OnClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAssinarLivroVisitas.Click
        If ok Then
            Assinar()
        End If
    End Sub
    Protected Sub Assinar()
        ' Le o arquivo XML em um XmlDataDocument assim podemos acessá-lo via DataSet
        Dim myXmlDataDocument As New XmlDataDocument()
        myXmlDataDocument.DataSet.DataSetName = "LivrodeVisitas"
        myXmlDataDocument.DataSet.ReadXmlSchema(strXmlSchema)
        myXmlDataDocument.Load(strXmlDocument)
        getIP()
        Dim LivrodeVisitasTable As DataTable
        LivrodeVisitasTable = myXmlDataDocument.DataSet.Tables("Entrada")

        ' Cria uma nova linha para entrar no livro de visitas
        Dim myDataRow As DataRow
        myDataRow = LivrodeVisitasTable.NewRow

        'Define os valores das linhas
        myDataRow.Item("Nome") = txtNome.Text
        myDataRow.Item("Data") = Now()
        myDataRow.Item("Mensagem") = txtMensagem.Text

        ' Inclui a linha na tabela
        LivrodeVisitasTable.Rows.Add(myDataRow)

        ' Escreve os dados na tabela
        myDataRow.AcceptChanges()

        ' Escreve os dados no DataSet
        myXmlDataDocument.DataSet.AcceptChanges()

        ' Escreve um novo arquivo XML
        myXmlDataDocument.DataSet.WriteXml(strXmlDocument, XmlWriteMode.IgnoreSchema)
        ok = False
        'vincula a fonte de dados ao controle repeater
        LivrodeVisitasRepeater.DataSource = LivrodeVisitasTable
        LivrodeVisitasRepeater.DataBind()
        txtNome.Text = ""
        txtMensagem.Text = ""
    End Sub

    Protected Sub getIP()
        ok = True
        ip = HttpContext.Current.Request.ServerVariables("HTTP_X_FORWARDED_FOR")

        If ip = String.Empty Or ip = Nothing Then
            ip = HttpContext.Current.Request.ServerVariables("REMOTE_ADDR")
        End If

        If ip = String.Empty Or ip = Nothing Then
            ip = HttpContext.Current.Request.UserHostAddress
        End If

        lblip.Text = " Seu endereço IP é : " + ip + "  e será registrado."
    End Sub
End Class
